Qt 5.6 | Qt 3D | C++ Classes | QGoochMaterial

Qt 5.6.3 Reference Documentation

# QGoochMaterial Class

(Qt3DRender::QGoochMaterial)

The QGoochMaterial provides a material that implements the Gooch shading model, popular in CAD and CAM applications. More...

Header: | #include <QGoochMaterial>
qmake: | QT += 3drender
Since: | Qt 5.5
Inherits: | QMaterial

- List of all members, including inherited members

## Properties

alpha : float beta : float cool : QColor diffuse : QColor | shininess : float specular : QColor warm : QColor

- 1 property inherited from Qt3DRender::QMaterial
- 1 property inherited from Qt3DCore::QComponent
- 2 properties inherited from Qt3DCore::QNode

## Public Functions

| QGoochMaterial(Qt3DCore::QNode *parent = Q_NULLPTR)
float | alpha() const
float | beta() const
QColor | cool() const
QColor | diffuse() const
float | shininess() const
QColor | specular() const
QColor | warm() const

- 6 public functions inherited from Qt3DRender::QMaterial
- 2 public functions inherited from Qt3DCore::QComponent
- 6 public functions inherited from Qt3DCore::QNode

## Public Slots

void | setAlpha(float alpha)
void | setBeta(float beta)
void | setCool(const QColor &cool)
void | setDiffuse(const QColor &diffuse)
void | setShininess(float shininess)
void | setSpecular(const QColor &specular)
void | setWarm(const QColor &warm)

- 1 public slot inherited from Qt3DRender::QMaterial
- 1 public slot inherited from Qt3DCore::QComponent
- 2 public slots inherited from Qt3DCore::QNode

## Signals

void | alphaChanged(float alpha)
void | betaChanged(float beta)
void | coolChanged(const QColor &cool)
void | diffuseChanged(const QColor &diffuse)
void | shininessChanged(float shininess)
void | specularChanged(const QColor &specular)
void | warmChanged(const QColor &warm)

- 1 signal inherited from Qt3DRender::QMaterial
- 2 signals inherited from Qt3DCore::QComponent
- 2 signals inherited from Qt3DCore::QNode

## Protected Functions

| QGoochMaterial(QGoochMaterialPrivate &dd, Qt3DCore::QNode *parent = Q_NULLPTR)

- 1 protected function inherited from Qt3DRender::QMaterial
- 1 protected function inherited from Qt3DCore::QComponent
- 3 protected functions inherited from Qt3DCore::QNode

### Additional Inherited Members

- 1 static protected member inherited from Qt3DCore::QNode

## Detailed Description

The QGoochMaterial provides a material that implements the Gooch shading model, popular in CAD and CAM applications.

The Gooch lighting model uses both color and brightness to help show the curvature of 3D surfaces. This is often better than models such as Phong that rely purely upon changes in brightness. In situations such as in CAD and CAM applications where photorealism is not a goal, the Gooch shading model in conjunction with some kind of silhouette edge inking is a popular solution.

The Gooch lighting model is explained fully in the original Gooch paper. The Gooch model mixes a diffuse objetc color with a user-provided cool color and warm color to produce the end points of a color ramp that is used to shade the object based upon the cosine of the angle between the vector from the fragment to the light source and the fragment's normal vector. Optionally, a specular highlight can be added on top. The relative contributions to the cool and warm colors by the diffuse color are controlled by the alpha and beta properties respecitvely.

This material uses an effect with a single render pass approach and performs per fragment lighting. Techniques are provided for OpenGL 2, OpenGL 3 or above as well as OpenGL ES 2.

## Property Documentation

### alpha : float

Holds the current alpha value. The start point of the color ramp used by the Gooch shader is calculated as {c = cool + alpha * diffuse}.

Access functions:

float | alpha() const
void | setAlpha(float alpha)

Notifier signal:

void | alphaChanged(float alpha)

### beta : float

Holds the current beta value. The start point of the color ramp used by the Gooch shader is calculated as {c = warm + beta * diffuse}.

Access functions:

float | beta() const
void | setBeta(float beta)

Notifier signal:

void | betaChanged(float beta)

### cool : QColor

Holds the current cool color.

Access functions:

QColor | cool() const
void | setCool(const QColor &cool)

Notifier signal:

void | coolChanged(const QColor &cool)

### diffuse : QColor

Holds the current diffuse color.

Access functions:

QColor | diffuse() const
void | setDiffuse(const QColor &diffuse)

Notifier signal:

void | diffuseChanged(const QColor &diffuse)

### shininess : float

Holds the current shininess value. Higher values of shininess result in a smaller and brighter highlight.

Access functions:

float | shininess() const
void | setShininess(float shininess)

Notifier signal:

void | shininessChanged(float shininess)

### specular : QColor

Holds the current specular color.

Access functions:

QColor | specular() const
void | setSpecular(const QColor &specular)

Notifier signal:

void | specularChanged(const QColor &specular)

### warm : QColor

Holds the current warm color.

Access functions:

QColor | warm() const
void | setWarm(const QColor &warm)

Notifier signal:

void | warmChanged(const QColor &warm)

## Member Function Documentation

### QGoochMaterial::QGoochMaterial(Qt3DCore::QNode *parent = Q_NULLPTR)

Default constructs an instance of QGoochMaterial.

### `[protected]` QGoochMaterial::QGoochMaterial(QGoochMaterialPrivate &dd, Qt3DCore::QNode *parent = Q_NULLPTR)

Copy constructor.